mediastreamer2 2.11.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Macros | Typedefs | Enumerations | Functions
Filter API - Manage mediastreamer2 filters
Mediastreamer2's base APIs

Filter API to manage mediastreamer2 filters. More...

## Macros
#define | MS_FILTER_METHOD(_id_, _count_, _argtype_) MS_FILTER_METHOD_ID(_id_,_count_,sizeof(_argtype_))
#define | MS_FILTER_METHOD_NO_ARG(_id_, _count_) MS_FILTER_METHOD_ID(_id_,_count_,0)
#define | MS_FILTER_SET_SAMPLE_RATE MS_FILTER_BASE_METHOD(0,int)
#define | MS_FILTER_GET_SAMPLE_RATE MS_FILTER_BASE_METHOD(1,int)
#define | MS_FILTER_SET_BITRATE MS_FILTER_BASE_METHOD(2,int)
#define | MS_FILTER_GET_BITRATE MS_FILTER_BASE_METHOD(3,int)
#define | MS_FILTER_ADD_FMTP MS_FILTER_BASE_METHOD(7,const char)
#define | MS_FILTER_GET_LATENCY MS_FILTER_BASE_METHOD(11,int)
#define | MS_FILTER_GET_INPUT_FMT MS_FILTER_BASE_METHOD(30,MSPinFormat)
#define | MS_FILTER_SET_INPUT_FMT MS_FILTER_BASE_METHOD(31,MSPinFormat)
#define | MS_FILTER_GET_OUTPUT_FMT MS_FILTER_BASE_METHOD(32,MSPinFormat)
#define | MS_FILTER_SET_OUTPUT_FMT MS_FILTER_BASE_METHOD(33,MSPinFormat)
#define | MS_FILTER_OUTPUT_FMT_CHANGED MS_FILTER_BASE_EVENT_NO_ARG(0)

## Typedefs
typedef void(* | MSFilterFunc )(struct _MSFilter *f)
typedef int(* | MSFilterMethodFunc )(struct _MSFilter *f, void *arg)
typedef void(* | MSFilterNotifyFunc )(void *userdata, struct _MSFilter *f, unsigned int id, void *arg)
typedef enum _MSFilterInterfaceId | MSFilterInterfaceId
typedef struct _MSFilterMethod | MSFilterMethod
typedef enum _MSFilterCategory | MSFilterCategory
typedef enum _MSFilterFlags | MSFilterFlags
typedef struct _MSFilterDesc | MSFilterDesc
typedef struct _MSFilter | MSFilter
typedef struct _MSConnectionPoint | MSConnectionPoint
typedef struct _MSConnectionHelper | MSConnectionHelper

## Enumerations
enum | _MSFilterInterfaceId { , MSFilterPlayerInterface, MSFilterRecorderInterface, MSFilterVideoDisplayInterface , MSFilterVideoDecoderInterface, MSFilterVideoCaptureInterface, MSFilterAudioDecoderInterface, MSFilterVideoEncoderInterface, MSFilterAudioCaptureInterface , MSFilterAudioEncoderInterface, MSFilterVoidInterface }
enum | _MSFilterCategory { MS_FILTER_OTHER, MS_FILTER_ENCODER, MS_FILTER_DECODER, MS_FILTER_ENCODING_CAPTURER, MS_FILTER_DECODER_RENDERER }
enum | _MSFilterFlags { MS_FILTER_IS_PUMP = 1 }

## Functions
void | ms_filter_register (MSFilterDesc *desc)
MSFilterDesc * | ms_filter_get_encoding_capturer (const char *mime)
MSFilterDesc * | ms_filter_get_decoding_renderer (const char *mime)
MSFilterDesc * | ms_filter_get_encoder (const char *mime)
MSFilterDesc * | ms_filter_get_decoder (const char *mime)
MSFilterDesc * | ms_filter_lookup_by_name (const char *filter_name)
MSList * | ms_filter_lookup_by_interface (MSFilterInterfaceId id)
MSFilter * | ms_filter_create_encoder (const char *mime)
MSFilter * | ms_filter_create_decoder (const char *mime)
bool_t | ms_filter_codec_supported (const char *mime)
MSFilter * | ms_filter_new (MSFilterId id)
MSFilter * | ms_filter_new_from_name (const char *name)
MSFilter * | ms_filter_new_from_desc (MSFilterDesc *desc)
int | ms_filter_link (MSFilter *f1, int pin1, MSFilter *f2, int pin2)
int | ms_filter_unlink (MSFilter *f1, int pin1, MSFilter *f2, int pin2)
int | ms_filter_call_method (MSFilter *f, unsigned int id, void *arg)
int | ms_filter_call_method_noarg (MSFilter *f, unsigned int id)
bool_t | ms_filter_has_method (MSFilter *f, unsigned int id)
bool_t | ms_filter_implements_interface (MSFilter *f, MSFilterInterfaceId id)
bool_t | ms_filter_desc_implements_interface (MSFilterDesc *desc, MSFilterInterfaceId id)
void | ms_filter_add_notify_callback (MSFilter *f, MSFilterNotifyFunc fn, void *userdata, bool_t synchronous)
void | ms_filter_remove_notify_callback (MSFilter *f, MSFilterNotifyFunc fn, void *userdata)
MSFilterId | ms_filter_get_id (MSFilter *f)
const char * | ms_filter_get_name (MSFilter *f)
MSList * | ms_filter_find_neighbours (MSFilter *me)
void | ms_filter_destroy (MSFilter *f)
void | ms_connection_helper_start (MSConnectionHelper *h)
int | ms_connection_helper_link (MSConnectionHelper *h, MSFilter *f, int inpin, int outpin)
| Enter a MSFilter to be connected into the MSConnectionHelper object. More...
int | ms_connection_helper_unlink (MSConnectionHelper *h, MSFilter *f, int inpin, int outpin)
| Enter a MSFilter to be disconnected into the MSConnectionHelper object. Process exactly the same way as ms_connection_helper_link() but calls ms_filter_unlink() on the entered filters.
void | ms_filter_enable_statistics (bool_t enabled)
| Enable processing time measurements statistics for filters.
void | ms_filter_reset_statistics (void)
| Reset processing time statistics for filters.
const MSList * | ms_filter_get_statistics (void)
| Retrieves statistics for running filters. Returns a list of MSFilterStats.
void | ms_filter_log_statistics (void)
| Logs runtime statistics for running filters.

## Detailed Description

Filter API to manage mediastreamer2 filters.

This section documents the API needed to create, link, unlink, find and destroy filters.

It also provides definitions if you wish to implement your own filters.

## Macro Definition Documentation

#define MS_FILTER_METHOD | ( |  | _id_,
|  |  | _count_,
|  |  | _argtype_
| ) |  | MS_FILTER_METHOD_ID(_id_,_count_,sizeof(_argtype_))

Macro to create a method id, unique per filter. First argument shall be the filter's ID (MSFilterId) or interface ID (MSFilterInterfaceId). Second argument is the method index within the context of the filter. It should start from 0 and increment for each new method. Third argument is the argument type of the method, for example "int", "float" or any structure.

#define MS_FILTER_METHOD_NO_ARG | ( |  | _id_,
|  |  | _count_
| ) |  | MS_FILTER_METHOD_ID(_id_,_count_,0)

Same as MS_FILTER_METHOD, but for method that do not take any argument.

#define MS_FILTER_SET_SAMPLE_RATE MS_FILTER_BASE_METHOD(0,int)

some MSFilter base generic methods: Set filter output/input sampling frequency in hertz

#define MS_FILTER_GET_SAMPLE_RATE MS_FILTER_BASE_METHOD(1,int)

Get filter output/input sampling frequency in hertz

#define MS_FILTER_SET_BITRATE MS_FILTER_BASE_METHOD(2,int)

Set filter output network bitrate in bit per seconds, this value include IP+UDP+RTP overhead

#define MS_FILTER_GET_BITRATE MS_FILTER_BASE_METHOD(3,int)

Get filter output network bitrate in bit per seconds, this value include IP+UDP+RTP overhead

#define MS_FILTER_ADD_FMTP MS_FILTER_BASE_METHOD(7,const char)

Set codec dependent attributes as taken from the SDP

#define MS_FILTER_GET_LATENCY MS_FILTER_BASE_METHOD(11,int)

Filters can return their latency in milliseconds (if known) using this method:

#define MS_FILTER_GET_INPUT_FMT MS_FILTER_BASE_METHOD(30,MSPinFormat)

Obtain the format of a filter on a given input

#define MS_FILTER_SET_INPUT_FMT MS_FILTER_BASE_METHOD(31,MSPinFormat)

Set the format of a filter on a given input

#define MS_FILTER_GET_OUTPUT_FMT MS_FILTER_BASE_METHOD(32,MSPinFormat)

Obtain the format of a filter on a given output

#define MS_FILTER_SET_OUTPUT_FMT MS_FILTER_BASE_METHOD(33,MSPinFormat)

Set the format of a filter on a given output

#define MS_FILTER_OUTPUT_FMT_CHANGED MS_FILTER_BASE_EVENT_NO_ARG(0)

MSFilter generic eventstriggered whenever a filter decides to change its output format for one or more more output pins

## Typedef Documentation

MSFilterFunc

Structure for filter's methods (init, preprocess, process, postprocess, uninit).

MSFilterMethodFunc

Structure for filter's methods used to set filter's options.

MSFilterNotifyFunc

Structure for filter's methods used as a callback to notify events.

typedef enum _MSFilterInterfaceId MSFilterInterfaceId

Interface IDs, used to generate method names (see MS_FILTER_METHOD macro).

MSFilterMethod

Structure for holding filter's methods to set filter's options.

MSFilterCategory

Structure to describe filter's category.

        MS_FILTER_OTHER
        MS_FILTER_ENCODER
        MS_FILTER_DECODER
        MS_FILTER_ENCODING_CAPTURER
        MS_FILTER_DECODING_RENDERER

typedef enum _MSFilterFlags MSFilterFlags

Filter's flags controlling special behaviours.

MSFilterDesc

Structure for filter's description.

MSFilter

Structure of filter's object.

MSConnectionPoint

Structure that represents a connection point of a MSFilter

MSConnectionHelper

Structure that holds data when using the ms_connection_helper_* functions.

## Enumeration Type Documentation

enum _MSFilterInterfaceId

Interface IDs, used to generate method names (see MS_FILTER_METHOD macro). The purpose of these interfaces is to allow different filter implementations to share the same methods, by implementing the method definitions for these interfaces. For example every video encoder implementation would need a method to request the generation of a key frame. Instead of having each implementation defining its own method to do this, each implementation can just implement the MS_VIDEO_ENCODER_REQ_VFU method of the MSFilterVideoEncoderInterface.

Enumerator
MSFilterPlayerInterface | Player interface, used to control playing of files.
MSFilterRecorderInterface | Recorder interface, used to control recording of stream into files.
MSFilterVideoDisplayInterface | Video display interface, used to control the rendering of raw pictures onscreen.
MSFilterVideoDecoderInterface | Echo canceller interface, used to control echo canceller implementations. Video decoder interface
MSFilterVideoCaptureInterface | Video capture interface
MSFilterAudioDecoderInterface | Audio Decoder interface
MSFilterVideoEncoderInterface | Video encoder interface
MSFilterAudioCaptureInterface | Interface for audio capture filters
MSFilterAudioEncoderInterface | Interface for audio playback filters. Video encoder interface
MSFilterVoidInterface | Void source/sink interface

enum _MSFilterCategory

Filter's category

Enumerator
MS_FILTER_OTHER | others
MS_FILTER_ENCODER | used by encoders
MS_FILTER_DECODER | used by decoders
MS_FILTER_ENCODING_CAPTURER | used by capture filters that perform encoding
MS_FILTER_DECODER_RENDERER | used by filters that perform decoding and rendering

enum _MSFilterFlags

Filter's flags controlling special behaviours.

Enumerator
MS_FILTER_IS_PUMP | The filter must be called in process function every tick.

## Function Documentation

void ms_filter_register | ( | MSFilterDesc * | desc | ) |

Register a filter description. (plugins use only!)

When you build your own plugin, this method will add the encoder or decoder to the internal list of supported codec. Then, this plugin can be used transparently from the application.

ms_filter_get_encoder, ms_filter_get_decoder, ms_filter_create_encoder, ms_filter_create_decoder and ms_filter_codec_supported can then be used as if the codec was internally. supported.

Parameters

  desc | a filter description.

MSFilterDesc* ms_filter_get_encoding_capturer | ( | const char * | mime | ) |

Retrieve capture filter that supports encoding to codec name.

Parameters

  mime | A string indicating the codec.

Returns: a MSFilterDesc if successfull, NULL otherwise.

MSFilterDesc* ms_filter_get_decoding_renderer | ( | const char * | mime | ) |

Retrieve render filter that supports decoding to codec name.

Parameters

  mime | A string indicating the codec.

Returns: a MSFilterDesc if successfull, NULL otherwise.

MSFilterDesc* ms_filter_get_encoder | ( | const char * | mime | ) |

Retrieve encoders according to codec name.

Internal supported codecs: PCMU, PCMA, speex, gsm Existing Public plugins: iLBC

Parameters

  mime | A string indicating the codec.

Returns: a MSFilterDesc if successfull, NULL otherwise.

MSFilterDesc* ms_filter_get_decoder | ( | const char * | mime | ) |

Retrieve decoders according to codec name.

Internal supported codecs: PCMU, PCMA, speex, gsm Existing Public plugins: iLBC

Parameters

  mime | A string indicating the codec.

Returns: a MSFilterDesc if successfull, NULL otherwise.

MSFilterDesc* ms_filter_lookup_by_name | ( | const char * | filter_name | ) |

Lookup a mediastreamer2 filter using its name. If found, the descriptor (MSFilterDesc) is returned. This descriptor can be used to instanciate the filter using ms_filter_new_from_desc() This function can be useful to query the presence of a filter loaded as a plugin, for example.

Parameters

  filter_name | The filter name.

MSList* ms_filter_lookup_by_interface | ( | MSFilterInterfaceId | id | ) |

Returns a list of filter descriptions implementing a given interface. The list itself must be freed by the caller of this function, but not the MSFilterDesc pointed by the list elements.

Parameters

  id | a filter interface id

Returns
  a newly allocated MSList of MSFilterDesc.

MSFilter* ms_filter_create_encoder | ( | const char * | mime | ) |

Create encoder filter according to codec name.

Internal supported codecs: PCMU, PCMA, speex, gsm Existing Public plugins: iLBC

Parameters

  mime | A string indicating the codec.

Returns: a MSFilter if successfull, NULL otherwise.

MSFilter* ms_filter_create_decoder | ( | const char * | mime | ) |

Create decoder filter according to codec name.

Internal supported codecs: PCMU, PCMA, speex, gsm Existing Public plugins: iLBC

Parameters

  mime | A string indicating the codec.

Returns: a MSFilter if successfull, NULL otherwise.

bool_t ms_filter_codec_supported | ( | const char * | mime | ) |

Check if a encode or decode filter exists for a codec name.

Internal supported codecs: PCMU, PCMA, speex, gsm Existing Public plugins: iLBC

Parameters

  mime | A string indicating the codec.

Returns: TRUE if successfull, FALSE otherwise.

MSFilter* ms_filter_new | ( | MSFilterId | id | ) |

Create decoder filter according to a filter's MSFilterId.

Parameters

  id | A MSFilterId identifier for the filter.

Returns: a MSFilter if successfull, NULL otherwise.

MSFilter* ms_filter_new_from_name | ( | const char * | name | ) |

Create decoder filter according to a filter's name.

Parameters

  name | A name for the filter.

Returns: a MSFilter if successfull, NULL otherwise.

MSFilter* ms_filter_new_from_desc | ( | MSFilterDesc * | desc | ) |

Create decoder filter according to a filter's description.

The primary use is to create your own filter's in your application and avoid registration inside mediastreamer2.

Parameters

  desc | A MSFilterDesc for the filter.

Returns: a MSFilter if successfull, NULL otherwise.

int ms_filter_link | ( | MSFilter * | f1,
|  | int | pin1,
|  | MSFilter * | f2,
|  | int | pin2
| ) |  |

Link one OUTPUT pin from a filter to an INPUT pin of another filter.

All data coming from the OUTPUT pin of one filter will be distributed to the INPUT pin of the second filter.

Parameters

  f1 | A MSFilter object containing the OUTPUT pin
  pin1 | An index of an OUTPUT pin.
  f2 | A MSFilter object containing the INPUT pin
  pin2 | An index of an INPUT pin.

Returns: 0 if sucessful, -1 otherwise.

int ms_filter_unlink | ( | MSFilter * | f1,
|  | int | pin1,
|  | MSFilter * | f2,
|  | int | pin2
| ) |  |

Unlink one OUTPUT pin from a filter to an INPUT pin of another filter.

Parameters

  f1 | A MSFilter object containing the OUTPUT pin
  pin1 | An index of an OUTPUT pin.
  f2 | A MSFilter object containing the INPUT pin
  pin2 | An index of an INPUT pin.

Returns: 0 if sucessful, -1 otherwise.

int ms_filter_call_method | ( | MSFilter * | f,
|  | unsigned int | id,
|  | void * | arg
| ) |  |

Call a filter's method to set or get options.

Parameters

  f | A MSFilter object.
  id | A private filter ID for the option.
  arg | A private user data for the filter.

Returns: 0 if successfull, -1 otherwise.

int ms_filter_call_method_noarg | ( | MSFilter * | f,
|  | unsigned int | id
| ) |  |

Call a filter's method to set options.

Parameters

  f | A MSFilter object.
  id | A method ID.

Returns: 0 if successfull, -1 otherwise.

bool_t ms_filter_has_method | ( | MSFilter * | f,
|  | unsigned int | id
| ) |  |

Returns whether the filter implements a given method

Parameters

  f | A MSFilter object.
  id | A method ID.

Returns: TRUE if method is implemented, FALSE otherwise.

bool_t ms_filter_implements_interface | ( | MSFilter * | f,
|  | MSFilterInterfaceId | id
| ) |  |

Returns whether a filter implements a given interface.

Parameters

  f | a MSFilter object
  id | an interface id.

Returns TRUE if interface is implemented, FALSE, otherwise.

bool_t ms_filter_desc_implements_interface | ( | MSFilterDesc * | desc,
|  | MSFilterInterfaceId | id
| ) |  |

Returns whether a filter implements a given interface, based on the filter's descriptor.

Parameters

  f | a MSFilter object
  id | an interface id.

Returns TRUE if interface is implemented, FALSE, otherwise.

void ms_filter_add_notify_callback | ( | MSFilter * | f,
|  | MSFilterNotifyFunc | fn,
|  | void * | userdata,
|  | bool_t | synchronous
| ) |  |

Set a callback on filter's to be informed of private filter's event. This callback is called from the filter's MSTicker, unless a global event queue is created to receive all filter's notification asynchronously. See ms_event_queue_new() for details.

Parameters

  f | A MSFilter object.
  fn | A MSFilterNotifyFunc that will be called.
  userdata | A pointer to private data.

Deprecated:
  use ms_filter_add_notify_callback()

Set a callback on filter's to be informed of private filter's event. This callback is called from the filter's MSTicker, unless a global event queue is created to receive all filter's notification or synchronous flag is TRUE. See ms_event_queue_new() for details.

Parameters

  f | A MSFilter object.
  fn | A MSFilterNotifyFunc that will be called.
  userdata | A pointer to private data.
  synchronous | boolean that indicates whether this callback must be called synchronously.

void ms_filter_remove_notify_callback | ( | MSFilter * | f,
|  | MSFilterNotifyFunc | fn,
|  | void * | userdata
| ) |  |

Remove a notify callback previously entered with ms_filter_add_notify_callback()

Parameters

  f | A MSFilter object.
  fn | A MSFilterNotifyFunc that will be called.
  userdata | A pointer to private data.

MSFilterId ms_filter_get_id | ( | MSFilter * | f | ) |

Get MSFilterId's filter.

Parameters

  f | A MSFilter object.

Returns: MSFilterId if successfull, -1 otherwise.

const char* ms_filter_get_name | ( | MSFilter * | f | ) |

Get filter's name.

Parameters

  [in] | f | MSFilter object

Returns
  The name of the filter.

MSList* ms_filter_find_neighbours | ( | MSFilter * | me | ) |

Obtain the list of current filter's neighbours, ie filters that are part of same graph.

Returns: a MSList of MSFilter, that needs to be freed by the caller when no more needed.

void ms_filter_destroy | ( | MSFilter * | f | ) |

Destroy a filter object.

Parameters

  f | A MSFilter object.

void ms_connection_helper_start | ( | MSConnectionHelper * | h | ) |

Initialize a MSConnectionHelper.

Parameters

  h | A MSConnectionHelper, usually (but not necessarily) on stack

int ms_connection_helper_link | ( | MSConnectionHelper * | h,
|  | MSFilter * | f,
|  | int | inpin,
|  | int | outpin
| ) |  |

Enter a MSFilter to be connected into the MSConnectionHelper object.

This functions enters a MSFilter to be connected into the MSConnectionHelper object and connects it to the last entered if not the first one. The MSConnectionHelper is useful to reduce the amount of code necessary to create graphs in case the connections are made in an ordered manner and some filters are present conditionally in graphs. For example, instead of writing

1 ms_filter_link(f1,0,f2,1);
2 ms_filter_link(f2,0,f3,0);
3 ms_filter_link(f3,1,f4,0);

You can write:

1 MSConnectionHelper h;
2 ms_connection_helper_start(&h);
3 ms_connection_helper_link(&h,f1,-1,0);
4 ms_connection_helper_link(&h,f2,1,0);
5 ms_connection_helper_link(&h,f3,0,1);
6 ms_connection_helper_link(&h,f4,0,-1);

Which is a bit longer to write here, but now imagine f2 needs to be present in the graph only in certain conditions: in the first case you have rewrite the two first lines, in the second case you just need to replace the fourth line by:

1 if (my_condition) ms_connection_helper_link(&h,f2,1,0);

Parameters

  h | a connection helper
  f | a MSFilter
  inpin | an input pin number with which the MSFilter needs to connect to previously entered MSFilter
  outpin | an output pin number with which the MSFilter needs to be connected to the next entered MSFilter

Returns: the return value of ms_filter_link() that is called internally to this function.